.486
.model flat, stdcall
option casemap :none

 include    \masm32\include\windows.inc 
 
 include    \masm32\include\kernel32.inc 
 include    \masm32\include\comdlg32.inc 
 include    \masm32\include\user32.inc 
 
 includelib     \masm32\lib\kernel32.lib
 includelib     \masm32\lib\comdlg32.lib
 includelib     \masm32\lib\user32.lib


CLASS_STYLE             equ 2003h
WINSTYLE                equ 2CF0000h
WINEXSTYLE              equ 189h

OFN_FLAGS               equ 000A0C04h
CREATE_FLAGS            equ 1F0FFFh
POPUP_FLAGS             equ 410h

MID_ABOUT               equ 201h
MID_EXIT                equ 202h
MID_PATCH               equ 203h
MID_UNPATCH             equ 204h

WHeight                 equ 150
WWidth                  equ 200


PATCH_SIZE              equ 8


.data?  
  
  hMenu               dd  ?
  hPopup              dd  ?
  hMapFile            dd  ?
  hMap                dd  ?
  
  file_size           dd  ?
  reverse_patch       dd  ?

  pathbuf             db  200h dup(?)
  nbytesrw            dd  ?
  MSGhWnd             dd  ?,?,?,?,?,?
    
  POINTx              dd  ?
  POINTy              dd  ?



.data

  patch_before        db  0B8h,058h,002h,000h,000h,099h,0F7h,0FFh
  patch_after         db  0B8h,058h,040h,000h,000h,099h,0F7h,0FFh

  APPNAME             db  "Map Editor Patcher",0
  CLASSNAME           db  "Lamb_Patcher",0

  OPENFILTER          db  "EXE Files",0,"*.exe",0,0 

  MENU_FILE           db  "&File",0
  MENU_PATCH          db  "&Patch",0
  MENU_UNPATCH        db  "&Unpatch",0
  MENU_ABOUT          db  "&About",0
  MENU_EXIT           db  "E&xit",0

  ABOUT_TEXT          db  "                 Lamby's Patcher",10
		      db  "         for Bliz War2 PUD editor",10,10
		      db  "(Removes the 75 unit per player limit)",10,10
		      db  "--> credz to tupac for digging up this  ",10
		      db  "  old djinnkhan info and reposting it",10,10
		      db  "                        hf =P",0

  OPEN_ERROR_TEXT     db  "      ERROR: Can't open file",10
		      db  "( is the program still running? )",0
  PATCH_ERROR_TEXT    db  "ERROR: Can't find patch location",10
		      db  "   ( correct program version? )",0
  PATCH_OK_TEXT       db  "Patch applied at offset 0x"
  PATCH_ADDRESS       db  "00000000",0

  filename            db  "Warcraft II Map Editor."
  fileextn            db  "exe",0
  directory           db  "C:\Program Files\War2CombatMapEditor",0
  sz_bak              db  "bak",0


  CEXcbSize            dd      30h
  CEXstyle             dd      CLASS_STYLE
  CEXlpfnWndProc       dd      OFFSET WndProc
  CEXcbClsExtra        dd      0
  CEXcbWndExtra        dd      0
  CEXhInstance         dd      0
  CEXhIcon             dd      0
  CEXhCursor           dd      0
  CEXhbrBackground     dd      10h
  CEXlpszMenuName      dd      0
  CEXlpszClassName     dd      OFFSET CLASSNAME
  CEXhIconSm           dd      0

  OFNlStructSize        dd      4Ch
  hWindow               dd      0                 ; OFNhwndOwner
  OFNhInstance          dd      0
  OFNlpstrFilter        dd      OFFSET OPENFILTER
  OFNlpstrCustFilter    dd      0
  OFNnMaxCustFilter     dd      0
  OFNnFilterIndex       dd      1
  OFNlpstrFile          dd      OFFSET filename
  OFNnMaxFile           dd      200h
  OFNlpstrFileTitle     dd      0
  OFNnMaxFileTitle      dd      0
  OFNlpstrInitialDir    dd      OFFSET directory
  OFNlpstrTitle         dd      0
  OFNFlags              dd      OFN_FLAGS
  OFNnFileOffset        dw      0
  OFNnfileExtension     dw      0
  OFNlpstrDefExt        dd      0
  OFNlCustData          dd      0
  OFNlpfnHook           dd      0
  OFNlpTemplateName     dd      0
    
    
.code
    
map_file proc path:DWORD
  push 0
  push 0
  push OPEN_EXISTING
  push 0
  push FILE_SHARE_READ or FILE_SHARE_WRITE
  push GENERIC_READ or GENERIC_WRITE
  push path
  call CreateFileA
  cmp eax,INVALID_HANDLE_VALUE

  jne @F
    ; error message
    push 0
    push path
    push OFFSET OPEN_ERROR_TEXT
    push hWindow
    call MessageBoxA
    xor eax,eax
    ret
  @@:
  mov hMapFile,eax

  ; get file size
  push 0
  push hMapFile
  call GetFileSize
  mov file_size,eax

  ; create file mapping object
  push 0
  push 0
  push 0
  push PAGE_READWRITE
  push 0
  push hMapFile
  call CreateFileMapping
  mov hMap,eax

  ; map the file to memory
  push 0
  push 0
  push 0
  push (FILE_MAP_READ OR FILE_MAP_WRITE)
  push eax
  call MapViewOfFile
  ret
map_file endp

close_file_map proc ptrMap:DWORD
  ; flush the map
  push 0
  push ptrMap
  call FlushViewOfFile
  
  ; unmap the file
  push ptrMap
  call UnmapViewOfFile
      
  ; close the file mapping object
  push hMap
  call CloseHandle
  
  ; close the file
  push hMapFile
  call CloseHandle

  ret
close_file_map endp

strlen proc saddr:DWORD ;
  mov eax, saddr
  dec eax
  @@:
    inc eax
    cmp byte ptr [eax], 0
  jnz @B
  sub eax, saddr
  ret
strlen endp

do_backup proc ptrMap:DWORD
  cmp reverse_patch,0
  jz @F
    ret
  @@:
  pushad
  
  mov edi,OFFSET pathbuf
  push edi
  call strlen
  
  lea edi,[edi+eax-3]
  mov esi,OFFSET sz_bak
  
  push edi
  push [edi]
  
    mov eax,[esi]
    mov [edi],eax
  
  
    push 0
    push 0
    push CREATE_ALWAYS
    push 0
    push FILE_SHARE_READ or FILE_SHARE_WRITE
    push GENERIC_READ or GENERIC_WRITE
    push OFFSET pathbuf
    call CreateFileA
    
    cmp eax,INVALID_HANDLE_VALUE
    je @F
      
      push eax
      
	push 0
	push OFFSET nbytesrw
	push file_size
	push ptrMap
	push eax
	call WriteFile
    
      call CloseHandle

    @@:
  
  pop eax
  pop edi
  mov [edi],eax
  
  popad
  ret
do_backup endp

test_location proc saddr:DWORD,daddr:DWORD
  push ecx
  push esi
  push edi
  mov ecx,PATCH_SIZE
  mov esi,saddr
  mov edi,daddr
  repe cmpsb
  mov eax,0
  jne @F
    mov eax,saddr
  @@:
  pop edi
  pop esi
  pop ecx
  ret
test_location endp

apply_patch proc daddr:DWORD,saddr:DWORD
  mov ecx,PATCH_SIZE
  mov esi,saddr
  mov edi,daddr
  @@:
    mov al,BYTE ptr[esi]
    mov [edi],al
    inc esi
    inc edi
  loop @B
  ret
apply_patch endp

do_patch proc path:DWORD

LOCAL ptrMap
LOCAL before
LOCAL after
  
  ; load and map the file
  push path
  call map_file
  test eax,eax
  jnz @F
    ret
  @@:
  mov ptrMap,eax
  
  ; swap the patch info if unpatching
  push OFFSET patch_before
  push OFFSET patch_after
  cmp reverse_patch,0
  jz @F
    pop before
    pop after
    jmp done_rev
  @@:
  pop after
  pop before
  
  done_rev:
  
  ; get the search extent
  mov ecx,file_size
  cmp ecx,PATCH_SIZE
  ja @F
    ; file is smaller than the patch (nope!)
    push ptrMap
    call close_file_map
    xor eax,eax
    ret
  @@:
  sub ecx,PATCH_SIZE
  
  ; find the patch location
  mov esi,eax
  mov ebx,before
  mov ebx,[ebx]
  
  search_loop:
    
    cmp ebx,[esi]
    jnz @F
      push before
      push esi
      call test_location
      test eax,eax
      jz @F
	;found location
	push eax
	  
	  ; save a backup if applying
	  push ptrMap
	  call do_backup
	
	  ; patch it
	  push after
	  push eax
	  call apply_patch
	
	  ; close the file
	  push ptrMap
	  call close_file_map
	
	; return the patch offset
	pop eax
	sub eax,ptrMap
	ret
    @@:
    inc esi
  loop search_loop
  
  ; patch location not found
  
  ; close the file
  push ptrMap
  call close_file_map
  
  ; error message
  push 0
  push path
  push OFFSET PATCH_ERROR_TEXT
  push hWindow
  call MessageBoxA
  
  ; return 0
  xor eax,eax
  ret
do_patch endp

hexstring proc     num:DWORD,
	       outaddr:DWORD,
	       ndigits:DWORD
    
    mov eax,outaddr
    add eax,ndigits
    mov edi,eax
    mov eax,num
    
    hsloop:
      
      dec edi
      mov ebx,eax
      and ebx,0Fh
      
      cmp ebx,9
      jle @F
	add ebx,7
      @@:
      
      add ebx,48
      mov byte ptr[edi],bl
      shr eax,4
    
      test eax,eax
    jnz hsloop
    
    cmp edi,outaddr
    jbe hsout
      @@:
	dec edi
	mov byte ptr[edi],48
      cmp edi,outaddr
      jnz @B
    hsout:
    ret
hexstring endp

track_popup:
  push OFFSET POINTx
  call GetCursorPos

  push 0
  push hWindow
  push POINTy
  push POINTx
  push 0
  push hPopup
  call TrackPopupMenuEx
  ret



WndProc PROC WPhWnd   :DWORD,
	     WPuMsg   :DWORD,
	     WPwParam :DWORD,
	     WPlParam :DWORD

    cmp WPuMsg, WM_COMMAND
    jz do_command
	  
	cmp WPuMsg, WM_DESTROY
	jnz @F
	  push 0
	  call PostQuitMessage
	@@:
	  
	cmp WPuMsg, WM_RBUTTONUP
	jnz @F
	  call track_popup
	  ret
	@@:
	
	push WPlParam
	push WPwParam
	push WPuMsg
	push WPhWnd
	call DefWindowProc
	ret
	
	
    do_command:
      cmp WPwParam,MID_EXIT
      jnz  @F
	push NULL
	call PostQuitMessage
	ret
      @@:
	    
      cmp WPwParam,MID_UNPATCH
      jnz @F
	mov reverse_patch,1
	jmp patch_start
      @@:
      
      cmp WPwParam,MID_PATCH
      jnz  @F
	mov reverse_patch,0
	
	patch_start:
	      
	mov esi,OFFSET filename
	mov edi,OFFSET pathbuf
	push esi
	call strlen
	mov ecx,eax
	cld
	rep movsb
	      
	push OFFSET OFNlStructSize
	call GetOpenFileNameA
	test eax,eax
	jz @F
	    push OFFSET pathbuf
	    call do_patch
	    test eax,eax
	    jz @F
	      push 8
	      push OFFSET PATCH_ADDRESS
	      push eax
	      call hexstring

	      push 0
	      push OFFSET pathbuf
	      push OFFSET PATCH_OK_TEXT
	      push hWindow
	      call MessageBoxA
	    
	      ; close the program when done
	      push NULL
	      call PostQuitMessage
	      ret
	@@:
	
	cmp WPwParam,MID_ABOUT
	jnz  @F
	  push 0
	  push OFFSET APPNAME
	  push OFFSET ABOUT_TEXT
	  push hWindow
	  call MessageBox
	  ret
	@@:

  ret
WndProc ENDP


start:

  push 0
  call GetModuleHandle
  mov  CEXhInstance,eax
  mov  OFNhInstance,eax

  push IDC_ARROW
  push 0
  call LoadCursor
  mov  CEXhCursor,eax

  push OFFSET CEXcbSize
  call RegisterClassEx

  call CreateMenu
  mov hMenu,eax
	
  call CreateMenu
  mov hPopup,eax
	
  push OFFSET MENU_FILE
  push hPopup
  push POPUP_FLAGS
  push hMenu
  call AppendMenu  

  push OFFSET MENU_PATCH
  push MID_PATCH
  push 0
  push hPopup
  call AppendMenu

  push OFFSET MENU_UNPATCH
  push MID_UNPATCH
  push 0
  push hPopup
  call AppendMenu

  push OFFSET MENU_ABOUT
  push MID_ABOUT
  push 0
  push hPopup
  call AppendMenu

  push OFFSET MENU_EXIT
  push MID_EXIT
  push 0
  push hPopup
  call AppendMenu

  push 0
  push CEXhInstance
  push hMenu
  push 0
  push WHeight
  push WWidth
  push CW_USEDEFAULT
  push CW_USEDEFAULT
  push WINSTYLE
  push OFFSET APPNAME
  push OFFSET CLASSNAME
  push WINEXSTYLE
  call CreateWindowEx
  mov hWindow,eax

  push 1
  push eax
  call ShowWindow

  message_loop:
    xor eax,eax
    push eax
    push eax
    push eax
    push OFFSET MSGhWnd
    call GetMessage
    cmp eax,0
    jz @F
      push OFFSET MSGhWnd
      call TranslateMessage
	push OFFSET MSGhWnd
      call DispatchMessage
  jmp message_loop
    @@:
  
  push 0
  call ExitProcess

  ret
end start

